require_relative 'spec_helper'

describe Sudoku::Coordinate do
  COORDINATE ||= Sudoku::Coordinate

  let(:coordinate5) { COORDINATE.new(5) }
  let(:coordinate7) { COORDINATE.new(7) }
  let(:coordinate0) { COORDINATE.new(0) }
  let(:coordinate8) { COORDINATE.new(8) }

  it 'accepts the number and COORDINATE in the constructor' do
    expect(COORDINATE.new(5).coordinate).to eq(5)
    expect(COORDINATE.new(COORDINATE.new(5)).coordinate).to eq(5)
  end

  it 'returns correct string' do
    expect(coordinate5.to_s).to eq(5.to_s)
    expect(coordinate5.to_s).not_to eq(10.to_s)
  end

  it 'converts to_i and to_int' do
    expect(coordinate5.to_i).to eq(5.to_i)
    expect(coordinate5.to_int).to eq(5.to_int)
    expect(coordinate5.to_i).not_to eq(10.to_i)
  end

  it 'compares with coordinate and number' do
    expect(coordinate5).to be < coordinate7
    expect(coordinate7).to be > coordinate5
    expect(coordinate5).to be == COORDINATE.new(5)
  end

  it 'accepts only vales from the interval 0-8 inclusive' do
    expect { COORDINATE.new(10) }.to raise_error ArgumentError
    expect { COORDINATE.new(-10) }.to raise_error ArgumentError
    expect { COORDINATE.new(0) }.not_to raise_error
    expect { COORDINATE.new(8) }.not_to raise_error
  end
end
