require 'spec_helper'

describe Sudoku::Solver do
  SOLVER ||= Sudoku::Solver
  CELL ||= Sudoku::Cell
  CELL_COORDINATES ||= Sudoku::CellCoordinates

  let(:factory) { Sudoku::GridFactory.new }

  before do
    factory.disable_log
  end

  context 'cells set solving' do
    let(:solver) { SOLVER.new(factory.create_full_grid) }
    let(:solvable) do
      (1..9).to_a.collect { |x| CELL.new(CELL_COORDINATES.random, false, x) }
    end

    it 'solves the 9 cells set' do
      expect(solver.cells_violated?(solvable)).to be false
    end

    it 'does not accept invalid set' do
      solvable[5].value = 4
      expect(solver.cells_violated?(solvable)).to be true
    end
  end
end
